/*
 *****************************************************************************
 * Copyright (C) 2005-2014 UC Mobile Limited. All Rights Reserved
 * File			: moon.js
 *
 * Description	: 日夜间模式切换
 *
 * Creation		: 2014/5/15
 * Author		: lixf@ucweb.com
 * History		: kexk@ucweb.com
                : wangqz@ucweb.com
 *			   Creation, 2014/5/15, lixf, Create the file
 ******************************************************************************
 **/


/*
 * 请勿直接修改 Theme.js 文件
 * 如需修改：
 *  1. checkout 夜间模式工程：http://gitlab.alibaba-inc.com/iOSUC/night-mode/tree/master
 *  2. 在夜间模式工程中修改 moon.js，再生成 Theme.js，替换 UCWEB 中的 Theme.js
 */

 ;(function(exports)
 {

    if (exports['$UCThemeManager']) return;

    /******************************************************************************
     *
     * 全局变量初始化及公共函数
     *
     ******************************************************************************/

     var $UCThemeManager =
     {
        Theme: {}
    };


    exports['$UCThemeManager'] = $UCThemeManager;

    // rgb 正则匹配
    var regBgTransparent = new RegExp('rgba\\(\\s*?\\d+?\\s*?,\\s*?\\d+?\\s*?,\\s*?\\d+?\\s*?,\\s*?0\\s*?\\)', 'i');
    var regBgWhite = new RegExp('rgb\\(\\s*?2\\d{2}\\s*?,\\s*?2\\d{2}\\s*?,\\s*?2\\d{2}\\s*?\\)', 'i');
    var regbdWhite = /rgb\(\s*?1(6|7|8|9)\d\s*?,\s*?1(6|7|8|9)\d\s*?,\s*?1(6|7|8|9)\d\s*?\)/i;
    var regBlackWithAlpha = /rgba?\((\s*0\s*,){2}\s*0\s*(,\s*(1|0\.\d*[1-9])\s*)?\)/i;
    var regWhiteWithAlpha = /rgba\(255\, 255\, 255\,/i;
    var regLinearBkgImg = /rgb|-webkit-gradient/i;

    var regExceptTag = /\bCANVAS\b|\bIMG\b|\bIFRAME\b|\bBR\b|\bSCRIPT\b/; //不需要处理的节点, BODY内的节点过滤
    var regAllExceptTag = /\bCANVAS\b|\bIMG\b|\bIFRAME\b|\bBR\b|\bSCRIPT\b|\bNOSCRIPT\b|\bSTYLE\b|\bMETA\b|\bLINK\b|\bTITLE\b/;//新插入节点的过滤
    var regStylePreDefineTags = /\bINPUT\b|\bSELECT\b/;

    var lazyImageAttributes = /\bdata-image\b|\ndata-original\b/
    //当前页是否wml页面, iPhone客户端wml页面有特殊的处理逻辑。onload之前div都是全透明的。
    var g_isWMLPage = false;

    var PROCESS_NODES_PER_TIME = 100; // 每次处理节点的个数
    var SLEEP_TIME_AFTER_PROCESS_ONCE = 5; //每次处理完节点等待的时间(让出cpu让系统处理dom更新 milliseconds)
    var nightModeChangingTimer = null;

    // 日夜间切换时用到的变量
    var startTime = 0;
    var backImgWidthThreshold =  window.innerWidth * 0.5; //非平铺背景图属性修改的宽度判断阈值，这个是经验值，可以根据实际情况作调整
    var reApplyTimer = null;
    var shouldChangeToEyeProtectFlag = null;
    var nightStyleClassMatchReg = /UCNightMode_[\s\S]*?\b/g;

    var bgWarnTransparent = '%s';

    /******************************************************************************
     *
     * 夜间模式样式的定义
     *
     ******************************************************************************/
     var themeStyleId = 'preucbrowser_sheet_theme';
     var themeStyle = '.UCUNNIC.UCNightMode_changeBgColor{background:#222222!important}.UCUNNIC.UCNightMode_setBackground{background:#222222!important;color:#EDF0F2!important}.UCUNNIC.UCNightMode_changeBgLinear{background:rgba(40,40,40,.6)!important}.UCUNNIC.UCNightMode_changeBorder{border-color:#465159!important}.UCUNNIC.UCNightMode_setBorder{outline:1px solid #303940}.UCUNNIC.UCNightMode_delBgImg{background-image:none!important}:not(.UCUNNIC){border-color:#465159!important;background-color:#222222!important}*{text-shadow:none!important;box-shadow:none!important}:after,:before{-webkit-filter:brightness(0.4)}body,html{background:#222222!important;color:#EDF0F2!important}abbr,address,article,aside,b,bdi,bdo,blockquote,br,caption,cite,code,col,colgroup,data,datalist,dc,dd,dfn,dl,dt,em,fieldset,figcaption,figure,footer,form,h1,h2,h3,h4,h5,h6,header,hr,i,kbd,keygen,label,legend,li,main,mark,meter,nav,ol,optgroup,option,output,p,pre,progress,q,rp,rt,ruby,s,samp,section,small,span,strong,sub,sup,table,tbody,td,textarea,tfoot,th,thead,time,tr,u,ul,var,wbr{background-color:none;color:#EDF0F2!important}textarea{background-color:#252D33!important}div,div.UCUNNIC{color:#EDF0F2!important}a,a *,a.UCUNNIC,a.UCUNNIC .UCUNNIC{color:#EDF0F2!important}a.UCUNNIC:visited,a.UCUNNIC:visited .UCUNNIC,a.UCUNNIC:visited div.UCUNNIC,a:visited,a:visited *{color:#CED4D9!important}button:not(.UCNightMode_transparentBkg):not(.UCUNNIC),div:not(.UCNightMode_transparentBkg):not(.UCUNNIC),input:not(.UCNightMode_transparentBkg):not(.UCUNNIC),select:not(.UCNightMode_transparentBkg):not(.UCUNNIC){background:#252D33!important}button.UCUNNIC_Done:not(.UCNightMode_transparentBkg):not(.UCNightMode_changeBgLinear):not(.UCNightMode_setBackground),div.UCUNNIC_Done:not(.UCNightMode_transparentBkg):not(.UCNightMode_changeBgLinear):not(.UCNightMode_setBackground),input.UCUNNIC_Done:not(.UCNightMode_transparentBkg):not(.UCNightMode_changeBgLinear):not(.UCNightMode_setBackground),select.UCUNNIC_Done:not(.UCNightMode_transparentBkg):not(.UCNightMode_changeBgLinear):not(.UCNightMode_setBackground){background-color:#252D33!important}input[type=date],input[type=date] *,input[type=datetime-local],input[type=datetime-local] *,input[type=month],input[type=month] *,input[type=time],input[type=time] *,select,select *{color:#EDF0F2!important}input:not([type=button]):not([type=submit]):not([type=reset]):not([type=image]):not([type=file]):not([type=date]):not([type=datetime-local]):not([type=month]):not([type=time]){color:#EDF0F2!important;border-color:#303940!important}button,input[type=button],input[type=file],input[type=image],input[type=reset],input[type=submit]{color:#EDF0F2!important;border-color:#303940!important}div#K_UCKWebkitReaderSeparator,div.uc_rmst_div{border-style:solid;border-width:1px;border-color:#303940!important}.threads_list{background:#000!important}textarea.se-input{background-color:#252D33!important}.threads_list .tl_shadow{border-bottom:1px solid #EDF0F2}.fixBar,.yk-TitleBar.fixedBar .titlebar{background-color:#252D33!important}p.img[data-norect]{background-image:none}div>i.img._4s0y:not(.UCUNNIC_Done){background-image:none!important;background-color:rgba(0,0,0,0)!important}a>i.img._4s0y:not(.UCUNNIC_Done){background-image:none!important;background-color:rgba(0,0,0,0)!important}div>div.profileMapTile._4p9n:not(.UCUNNIC_Done){background-color:rgba(0,0,0,0)!important;background-image:none!important}span[class^=hs_kw]:before{-webkit-filter:brightness(1)}';
     var eyeProtectStyle = '.UCUNNIC.UCNightMode_changeBgColor:not(.UCNightMode_positionFixed):not(.UCNightMode_BgBlack):not(.UCNightMode_ColorWhite):not(input[type=radio]):not([class*=btn]):not(button):not([role=button]):not(header):not(kbd):not([id*=search]):not([href^="javascript:"]):not(#J-menu):not([class*=logo]):not(nav):not(.add-to-cart):not(.buy-now):not(.yisou-poster):not(.navbar-header-left):not(.navbar-header-right):not(.sc_nba_schedule_lg):not(.score-wrap):not(.nba-schedule-nav):not(.header-box):not(.setPageHeightMarker),a.toggle_btn_up{background:#cce5d4!important}[class*=btn]:not(div):not(a):not(.UCNightMode_positionFixed):not(.UCNightMode_BgBlack):not(.UCNightMode_ColorWhite):not([class*=btn]):not(button):not([role=button]):not(header):not(span):not(kbd):not([id*=search]):not(#J-menu):not([class*=logo]):not(nav):not([href^="javascript:"]){background:#cce5d4!important}.UCUNNIC.UCNightMode_changeBgLinear.line-around,.UCUNNIC.UCNightMode_changeBgLinear.module-cover{background:#cce5d4!important}.UCUNNIC.UCNightMode_changeBorder:not(kbd){border-color:#a3c4a2!important}.UCUNNIC.UCNightMode_setBorder:not(.UCNightMode_changeBgLinear){outline:#a3c4a2 solid 1px}:not(.UCUNNIC):not(.top-fixed):not(.headbg):not(.city-change):not(.UCNightMode_BgBlack):not(.UCNightMode_ColorWhite):not([class*=logo]):not(nav):not([id*=search]){border-color:#a3c4a2!important;background-color:#cce5d4!important}body,html{background:#cce5d4!important}abbr,address,article,aside,b,bdi,bdo,blockquote,br,caption,cite,code,col,colgroup,data,datalist,dc,dd,dfn,dl,dt,em,fieldset,figcaption,figure,footer,form,h1,h2,h3,h4,h5,h6,header,hr,i,kbd,keygen,label,legend,li,main,mark,meter,nav,ol,optgroup,option,output,p,pre,progress,q,rp,rt,ruby,s,samp,section,small,span,strong,sub,sup,table,tbody,td,textarea,tfoot,th,thead,time,tr,u,ul,var,wbr{background-color:none}textarea{background-color:#cce5d4!important}div.UCUNNIC_Done:not(.UCNightMode_transparentBkg):not(.UCNightMode_changeBgLinear):not(.UCNightMode_setBackground):not(.UCNightMode_changeBgColor):not(.UCNightMode_ColorWhite){background-color:#cce5d4!important}input[type=date],input[type=date] *,input[type=datetime-local],input[type=datetime-local] *,input[type=month],input[type=month] *,input[type=time],input[type=time] *,select,select *{color:#fff!important}button,input:not([type=button]):not([type=submit]):not([type=reset]):not([type=image]):not([type=file]):not([type=date]):not([type=datetime-local]):not([type=month]):not([type=time]),input[type=button],input[type=file],input[type=image],input[type=reset],input[type=submit]{border-color:#a3c4a2!important}div#K_UCKWebkitReaderSeparator,div.uc_rmst_div{border-style:solid;border-width:1px;border-color:#a3c4a2!important}';

     var themeStyleElmt = document.createElement('style');
     themeStyleElmt.id = themeStyleId;
     themeStyleElmt.innerText = themeStyle;

     // 2020.3.10 fix: https://detail.m.tmall.com/item.htm?id=608928850207&tg_key=jhs&v=0&_target=_blank&spm=a2147.7632989.List.4.618e4f84rt4Yrl&ju_id=10000840942540&item_id=608928850207&_format=true
     themeStyle+='.mui-slider.UCUNNIC.UCNightMode_changeBorder{z-index:1}';

     function onDomRemoveOnHeader(event){
        if (event.target && event.target.id == themeStyleId)
        {
            reApplyTimer = window.setTimeout(function reApplyThemeStyle(){
                if ($UCThemeManager.Theme.theme == 'NightMode' || $UCThemeManager.Theme.theme == 'EyeProtect') {
                    document.documentElement.appendChild(themeStyleElmt);
                };

                reApplyTimer = null;
            }, 1);

            //只处理一次
            document.documentElement.removeEventListener('DOMNodeRemoved', onDomRemoveOnHeader, false);
        }
    }

     function applyThemeStyleSheet(theme)
     {
        if (theme == 'EyeProtect')
        {
            themeStyleElmt.innerText = eyeProtectStyle;
        }
        else
        {
            if (bgWarnTransparent === 'yes') {
                themeStyle += "body,html{background:#00373839!important;color:#dddcdc!important}:not(.UCUNNIC){border-color:#373839!important;background-color:#00373839!important}";
            }
            themeStyleElmt.innerText = themeStyle;
        }

        if (document.documentElement)
        {
            document.documentElement.appendChild(themeStyleElmt);

            //有些页面会删除插入的样式节点，这种情况下，尝试再应用一次
            document.documentElement.addEventListener('DOMNodeRemoved', onDomRemoveOnHeader, false);
        }
    }

    function removeThemeStyleSheet()
    {
        document.documentElement.removeEventListener('DOMNodeRemoved', onDomRemoveOnHeader, false);
        if (reApplyTimer)
        {
            window.clearTimeout(reApplyTimer);
        }

        var styleElmt = document.getElementById(themeStyleId);
        if (styleElmt && styleElmt.parentNode)
        {
            styleElmt.parentNode.removeChild(styleElmt);
        }
    }


    /******************************************************************************
     *
     * 夜间模式的处理
     *
     ******************************************************************************/

    /**
     *  @desc  完成单个节点的操作
     */
     function changeNodeToNightMode(node, exceptReg)
     {
        if (!node) { return; }
        if (node.nodeType == 3 || node.nodeType == 8) { return; }

        var tagName = node.tagName.toUpperCase();
        if (exceptReg && exceptReg.test(tagName)) { return; }

        if (node.classList.contains('UCUNNIC')) { return ; }
        node.classList.add('UCUNNIC');

        var computedStyle = window.getComputedStyle(node, null);
        if ( !computedStyle ) { return; }

        //处理背景
        var ntmClsName = calculateNTMClass(node, tagName, computedStyle);
        node.className += ntmClsName;

        node.classList.add('UCUNNIC_Done');
    }

    function getNodeNTMClass(node, exceptReg)
    {
        if (!node || node.nodeType == 3 || node.nodeType == 8) { return null; }

        var tagName = node.tagName.toUpperCase();
        if (exceptReg && exceptReg.test(tagName)) { return null; }

        var computedStyle = window.getComputedStyle(node, null);
        if ( !computedStyle ) { return null; }

        return calculateNTMClass(node, tagName, computedStyle);
    }
    //判断当前节点是否为Lazy Load类型的图片
    function isLazyLoadImageTag(node) {
        var attributes = node.attributes;
        var isLazyLoadTag = false
        if (attributes) {
            for (var i = 0; i<attributes.length; i++) {
                if (lazyImageAttributes.test(attributes[i].name)) {
                    isLazyLoadTag = true;
                    break;
                }
            }
        }
        return isLazyLoadTag;
     }

     /**
    * alpha < 0.1 是透明背景
    * @param {string} backgroundColor
    */
      function isBgTransparent(backgroundColor, alphaThreshold) {
        var threshold = alphaThreshold > 0 ? alphaThreshold : 0;
        var re = /rgba\(\s*\d+\s*,\s*\d+\s*,\s*\d+\s*,\s*([\d.]+)\)/i;
        if (re.test(backgroundColor) && +RegExp.$1 <= threshold) {
          return true;
        }
        return false;
      }

    /**
     *  @desc  处理节点背景
     */
     function calculateNTMClass(node, tagName, computedStyle)
     {
        var nodeWid = parseInt(computedStyle.width, 0);
        var nodeHei = parseInt(computedStyle.height, 0);

        var isYouku = location.hostname.indexOf('youku.com') >= 0;
        // fix: .ykplayer .x-video-button{background-color: rgba(0,0,0,.5);}
  //      var alphaThreshold = isYouku ? 0.6 : 0.1;
          var alphaThreshold = 0.6;

        var isTransparentBkg = isBgTransparent(computedStyle.backgroundColor, alphaThreshold) && !g_isWMLPage; //wml页面没有透明属性,在在初始计算透明属性时，得到的却时透明的。所以这里要过滤掉
        var isPositionFixed = (computedStyle.position == 'fixed');
        var isBgBlack = false;
        if (!isTransparentBkg)
        {
            // 不是透明背景，才判断是否为黑色背景
            isBgBlack = regBlackWithAlpha.test(computedStyle.backgroundColor);
        }

        var isColorWhite = regBgWhite.test(computedStyle.color);

       // 处理边框颜色
        var shouldAdd_changeBorder = false;
        if (regBgWhite.test(computedStyle.borderColor) || regbdWhite.test(computedStyle.borderColor))
        {
            shouldAdd_changeBorder = true;
        }

        var isLinearBkgImg = false;
        var isNeedDeleteBkgImg = false;
        var isNeedChangeBkgClr = false;
        do
        {
            if (computedStyle.backgroundImage !== '' && computedStyle.backgroundImage !== 'none')
            {
                //渐变的要删除
                var backImage = computedStyle.backgroundImage;
                if(backImage.indexOf('url(') == -1 && regLinearBkgImg.test(backImage)) // 渐变颜色的的直接去除背景
                {
                    isLinearBkgImg = true;
                    break;
                }

                //如果有背景图no-repeat保留
                var repeat = computedStyle.backgroundRepeat;
                if (repeat == 'no-repeat'){
                    break;
                }
                //repeat, 如果非小图。要删除
                else if (repeat == 'repeat' && (nodeWid > backImgWidthThreshold || nodeHei > 100)){
                    isNeedDeleteBkgImg = true;
                    break;
                };
            }
            else
            {
                //满足白色背景或高亮背景, 将背景色置为默认值
                if (!isTransparentBkg ||  regBgWhite.test(computedStyle.backgroundColor) || regWhiteWithAlpha.test(computedStyle.backgroundColor)  )
                {
                    if (!isLazyLoadImageTag(node)) {
                        isNeedChangeBkgClr = true;
                    }
                }
            }
        }
        while(0);

        var appendClass = '';
        if (isTransparentBkg) //透明背景色
        {
            if (isLinearBkgImg)
            {
                appendClass += ' UCNightMode_setBorder UCNightMode_changeBgLinear';
            }
            else if(isNeedDeleteBkgImg)
            {
                appendClass += ' UCNightMode_setBorder UCNightMode_delBgImg UCNightMode_transparentBkg';
            }
            else
            {
                appendClass += ' UCNightMode_transparentBkg';
            }
        }
        else
        {
            if (isLinearBkgImg)
            {
                appendClass += ' UCNightMode_setBorder UCNightMode_changeBgLinear';
            }
            else if(isNeedDeleteBkgImg)
            {
                appendClass += ' UCNightMode_setBorder UCNightMode_setBackground';
            }
        }

        if (isNeedChangeBkgClr)
        {
            appendClass += ' UCNightMode_changeBgColor';
        }

        if (shouldAdd_changeBorder)
        {
            appendClass += ' UCNightMode_changeBorder';
        }

        if (isPositionFixed)
        {
            appendClass += ' UCNightMode_positionFixed';
        }

        if (isBgBlack)
        {
            appendClass += ' UCNightMode_BgBlack';
        }

        if (isColorWhite)
        {
            appendClass += ' UCNightMode_ColorWhite';
        }

        //var bclr = computedStyle.borderColor ;
        //window.console.log(node.className + '###' + bclr + '#' + computedStyle.backgroundColor + '#' +computedStyle.backgroundImage + '#'+ isTransparentBkg + '#' + isLinearBkgImg + '#' + isNeedDeleteBkgImg + '#' + isNeedChangeBkgClr);
        return appendClass;
    }

    function isInIFrame()
    {
        return (window!=window.top);
    }
    function IFrameLogHeader()
    {
        if (window!=window.top)
            return "iFrame ";
        return "";
    }

    function iOSversion()
    {
        if (/iP(hone|od|ad)/.test(navigator.platform))
        {
            var v = (navigator.appVersion).match(/OS (\d+)_(\d+)_?(\d+)?/);
            return parseInt(v[1], 10);
        }
        return 8;//<找不到就默认为8
    }

    var g_iOSMainVersion = undefined;
    function iOSMainVersion()
    {
        if (g_iOSMainVersion == undefined)
        {
            g_iOSMainVersion = iOSversion();
        }
        return g_iOSMainVersion;
    }


    /**
     *  @desc  遍历节点，每次遍历PROCESS_NODES_PER_TIME个节点后让出一段cpu让系统处理dom节点更新
     */
    function changeNodeListToTheme(theme, node_list, from, to, exceptReg, onProcessFinish)
    {
        /**
         * @constructor
         */
        function ClsDict(node, cls)
        {
            this.node = node;
            this.cls = cls;
        }


        var max_index = Math.min(to, node_list.length);
        for (var i = from; i <=max_index; i++)
        {
            var node = node_list[i];
            if (node && node.classList)
            {
                // 夜间和护眼色模式切换时，需要移除已有的夜间模式class，避免重复添加class
                if (node.classList.contains('UCEyeProtect'))
                {
                    node.classList.remove('UCEyeProtect');
                }

                if (node.classList.contains('UCUNNIC_Done'))
                {
                    node.classList.remove('UCUNNIC_Done');
                }

                if (!node.classList.contains('UCUNNIC'))
                {
                    node.classList.add('UCUNNIC');
                }
                else
                {
                    removeNodeClassWithReg(node, nightStyleClassMatchReg);
                }
            }
        }

        var ntmClsCache = [];
        for (var ii = from; ii <= max_index; ii++)
        {
            var cls = getNodeNTMClass(node_list[ii], exceptReg);
            if(cls && cls.length > 0)
            {
                var item = new ClsDict(node_list[ii], cls);
                ntmClsCache.push(item);
            }
        }

        var cacheLen = ntmClsCache.length;
        var themePrefixCls = null;
        if (theme == 'EyeProtect')
        {
            themePrefixCls = 'UCEyeProtect';
        }

        for (var iii = 0; iii <=cacheLen; iii++)
        {
            var item = ntmClsCache[iii];
            if (item && item.node && item.node.className && item.cls && item.cls.length > 0)
            {
                var nclsname = item.node.className;
                if (themePrefixCls) {
                    nclsname = nclsname + ' ' + themePrefixCls;
                }

                nclsname = nclsname + ' ' + item.cls + ' ' + 'UCUNNIC_Done';
                item.node.className = nclsname;
            }
        }

        ntmClsCache = [];

        onProcessFinish(max_index);
    }

    /**
     *  @desc  页面加载完成后开始遍历页面节点
     */
     function changeAllTagsToTheme(theme, needCallback)
     {
        onChangeThemeStart(theme, needCallback);
        if (nightModeChangingTimer != null)
        {
            //window.console.log( IFrameLogHeader() + 'Night' + " change start and cancel timer");
            window.clearTimeout(nightModeChangingTimer);
        }

        // 监听是否都dom插入，先remove再add，避免重复add
        document.removeEventListener('DOMNodeInserted', onDOMNodeInserted, false);
        document.addEventListener('DOMNodeInserted', onDOMNodeInserted, false);

        // 获取所有dom节点
        var allTags = Array.prototype.slice.call(document.body.getElementsByTagName('*'));
        var tagsCount = allTags ? allTags.length : 0;
        startTime = Date.now();

        function finishCallback(current_index)
        {
            if (current_index >= tagsCount)
            {
//                //window.console.log( IFrameLogHeader() + ' Total Element Process:' + tagsCount + '; Process Times: ' + (Date.now() - startTime) + 'ms;');

                onChangeThemeFinish(theme, tagsCount, needCallback);
            }
            else
            {
                nightModeChangingTimer = window.setTimeout(changeNodeListToTheme
                                                           , SLEEP_TIME_AFTER_PROCESS_ONCE
                                                           , theme
                                                           , allTags
                                                           , current_index
                                                           , current_index + PROCESS_NODES_PER_TIME
                                                           , regExceptTag
                                                           , finishCallback);
            }
        }

        changeNodeListToTheme(theme, allTags, 0, PROCESS_NODES_PER_TIME, regExceptTag, finishCallback);

    }

    /**
     *  @desc  遍历处理处理新插入节点
     */
     function changeInsertNodeTreeToNightMode(node, exceptReg)
     {
        if ( !node ) { return ; }
        //window.console.log( IFrameLogHeader() + "insert children count:" + (node.children ? node.children.length : 0) );
        changeNodeToNightMode(node, exceptReg);

        var subNodes = node.children;
        var subNodeCount = subNodes ? subNodes.length : 0;
        for (var i = 0; i < subNodeCount; i++)
        {
            changeInsertNodeTreeToNightMode(subNodes[i], exceptReg);
        }
    }

    /**
     *  @desc  DOMNodeInserted 事件处理函数
     *  @param event
     */
     function onDOMNodeInserted(event)
     {
        //到下一个调用进行
         window.setTimeout(changeInsertNodeTreeToNightMode, 1, event.target, regAllExceptTag);
//        changeInsertNodeTreeToNightMode(event.target, regAllExceptTag);
    }

    /******************************************************************************
     *
     * 日夜间切换节点遍历的初始化及统计
     *
     ******************************************************************************/
    /**
     *  @desc theme开始处理
     */
     function onChangeThemeStart(themeString, needCallback)
     {
        //判断当前页面是否为wml页面，如果判断过早。wml相关的js可能还没来行及执行。导致判断出错
        g_isWMLPage = (window.g_wmlBrowser && typeof(window.g_wmlBrowser) == 'object') ? true : false;
    }

    /**
     *  @desc theme处理结束
     */
    function onChangeThemeFinish(themeString, totalTags, needCallback)
    {
//        window.console.log( IFrameLogHeader() + themeString + ' Total Element Process:' + totalTags + '; Process Times: ' + (Date.now() - startTime) + 'ms;');
        if(window.top != window)
        {
            return ;
        }

        var processTime = Date.now() - startTime;
        var params = (themeString == 'Night' && totalTags > 0) ? 'node='+totalTags+'&time='+processTime : '';

        if (needCallback)
        {
            __sendMessage('on_theme_process_finish' + params);
        }
        else if (params && params.length > 0)
        {
            __sendMessage('on_theme_process_performance' + params);
        }
    }

    /**
     *  @desc 向浏览器发送消息通知
     */
    function __sendMessage(msg)
    {
        UCBrowserMessageCenter.sendMessage(msg);
    }

    /******************************************************************************
     *
     * 日间模式的处理
     *
     ******************************************************************************/

    /**
     *  @desc 去除节点的夜间模式
     */
    function changeNodeListToClassicMode(node, classMatchReg)
    {
        if (!node) return;

        if (node.nodeType == 3 || node.nodeType == 8) return;

        var tagName = node.tagName.toUpperCase();
        if (regExceptTag.test(tagName))
        {
            return;
        }

        if (node.classList.contains('UCUNNIC'))
        {
            node.classList.remove('UCUNNIC');
            node.classList.remove('UCUNNIC_Done');
            node.classList.remove('UCEyeProtect');

            removeNodeClassWithReg(node, classMatchReg);
        }
    }

    function removeNodeClassWithReg(node, classMatchReg)
    {
        var UCNightModeArr = node.className && node.className.match && node.className.match(classMatchReg);

        if(!UCNightModeArr) return;
        var UCNightModeLength = UCNightModeArr.length;

        if(UCNightModeLength > 0)
        {
            for(var i = 0; i < UCNightModeLength; i++)
            {
                node.classList.remove(UCNightModeArr[i]);
            }
        }
    }


    /**
     *  @desc
     */
    function changeAllTagsToClassicMode(needCallback)
    {
        onChangeThemeStart('Classic', needCallback);
        if (nightModeChangingTimer != null)
        {
            //window.console.log( IFrameLogHeader() + 'Classic' + " change start and cancel timer");
            window.clearTimeout(nightModeChangingTimer);
        }

        document.removeEventListener('DOMNodeInserted', onDOMNodeInserted, false);

        var elmtList = Array.prototype.slice.call(document.getElementsByTagName('*'));
        var elmtCount = elmtList.length;

        for (var i = 0; i < elmtCount; ++i)
        {
            changeNodeListToClassicMode(elmtList[i], nightStyleClassMatchReg);
        }

        onChangeThemeFinish('Classic', elmtCount, needCallback);
    }

    /******************************************************************************
     *
     * 事件监听及日夜间切换管理
     *
     ******************************************************************************/

    /**
     *  @desc  修改iframes内部的样式
     */
    function changeIframesTheme(themeString)
    {
        var ucThemeString = 'PREUCBROWSER_THEME_' + themeString;
        var iframes = document.getElementsByTagName('iframe');

        for (var i = 0; i < iframes.length; ++i)
        {
            var iframeNode = iframes[i];
            iframeNode.contentWindow.postMessage(ucThemeString, '*');
        }
    }

    /**
     *  @desc 是否需要进行日夜间切换，某些定制页面自己处理夜间模式
     */
    function shouldChangeTheme()
    {
        if (isInIFrame() && window.top['UC_shouldChangeTheme'])
        {
            var topRes = window.top['UC_shouldChangeTheme']();
            //window.console.log( IFrameLogHeader() +"detect meta from topWindow:" + topRes);
            return topRes;
        }
        if (window.UCshouldChangeTheme != undefined)
        {
            return  window.UCshouldChangeTheme;
        }

        //排除小说阅读器
        if (typeof ucreader_directory != "undefined")
        {
            window.UCshouldChangeTheme = false;
            return false;
        }

        var bShouldChange = true;
        var mts = document.getElementsByTagName('meta');
        var mtlen = mts.length;
        for (var i = 0; i < mtlen; i++)
        {
            //中间件的小说模式等定制页面，自己实现了夜间模式，不需要再处理。
            if (mts[i].name && mts[i].name == 'nightmode' && mts[i].content == 'disable')
            {
                bShouldChange = false;
                window.UCshouldChangeTheme = false;
                break ;
            }
        }
        //window.console.log( IFrameLogHeader() +"detect meta :" + bShouldChange);
        return bShouldChange;
    }

    /**
     *  @desc 是否需要进行保护色模式切换
     */
    function shouldChangeToEyeProtect()
    {
        var bShouldChange = true;
        var url = location.href;
        do
        {
            try
            {
                if (isInIFrame() && window.top['UC_shouldChangeToEyeProtect'])
                {
                    bShouldChange = window.top['UC_shouldChangeToEyeProtect']();
                    break;
                }
            }
            catch(e) { }

            if (shouldChangeToEyeProtectFlag != null)
            {
                bShouldChange = shouldChangeToEyeProtectFlag;
                break;
            }

            if (location.href == 'about:blank')
            {
                bShouldChange = false;
                break;
            }

            //排除小说阅读器
            if (typeof ucreader_directory != "undefined")
            {
                shouldChangeToEyeProtectFlag = false;
                bShouldChange = false;
                break;
            }

            // 排除UC自己的垂直业务
            if (/https?:\/\/((ixs\.sm\.cn)|((hao|tv|qiqu|go)\.uc\.cn))\//i.test(url))
            {
                shouldChangeToEyeProtectFlag = false;
                bShouldChange = false;
                break;
            }

            // 排除信息流
            // 1. 含有参数sm_article_id
            // 2. 域名为*.uczzd.cn/*.sm.cn/*.uc.cn，含有aid参数，并且含有app或zzd_from参数
            // 3. zzd.sm.cn/webapp/index页面
            var isNewsFlow = false;
            if (/[?&]sm_article_id=/i.test(url))
            {
            	isNewsFlow = true;
            }
            else if (/https?:\/\/[a-zA-Z0-9\.]*\.(uczzd|sm|uc)\.cn/i.test(url) && /[?&]aid=/i.test(url) && /[?&](app|commentid|zzd_from)=/i.test(url))
            {
            	isNewsFlow = true;
            }
            else if (/https?:\/\/zzd\.sm\.cn\/webapp\/index/i.test(url))
            {
            	isNewsFlow = true;
            }

            if (isNewsFlow)
            {
            	shouldChangeToEyeProtectFlag = false;
                bShouldChange = false;
                break;
            }

            // 排除自媒体
            // 域名为*.mp.uc.cn/mparticle.uc.cn
            if (/https?:\/\/(([a-zA-Z0-9\.]+\.mp)|(mparticle))\.uc\.cn/i.test(url))
            {
            	shouldChangeToEyeProtectFlag = false;
                bShouldChange = false;
                break;
            }

            // 排除中间件转码小说
            if (document && document.head)
            {
                var metaFound = false;
                var mts = document.head.getElementsByTagName('meta');
                var mtlen = mts.length;
                for (var i = 0; i < mtlen; i++)
                {
                    if (mts[i].name && mts[i].name == 'customizetype' && mts[i].content == 'reader')
                    {
                        metaFound = true;
                        break;
                    }
                }

                if (metaFound)
                {
                    bShouldChange = false;
                    shouldChangeToEyeProtectFlag = false;
                    break;
                }
            }
        } while (false);

        return bShouldChange;
    }

    /**
     *  @desc 切换至夜间处理入口
     */
    function changeThemeToNightMode(needCallback)
    {
        if ( shouldChangeTheme() )
        {
            changeAllTagsToTheme('Night', needCallback);
        }
        else
        {
            removeThemeStyleSheet();
            this.theme = 'Classic';
        }
    }

    /**
     * @desc 切换至网页保护色入口
     */
    function changeToEyeProtectMode(needCallback)
    {
        if ( shouldChangeToEyeProtect() )
        {
            applyThemeStyleSheet('EyeProtect');
            changeAllTagsToTheme('EyeProtect', needCallback);
        }
        else
        {
            removeThemeStyleSheet();
            this.theme = 'Classic';
        }
    }

    /**
     *  @desc 切换至日间处理入口
     */
    function changeThemeToClassicMode(needCallback)
    {
        if ( shouldChangeTheme() )
        {
            changeAllTagsToClassicMode(needCallback);
        }
    }

    /**
     *  @desc   模式切换
     */
    $UCThemeManager['Theme'] =
    {
        theme: 'Classic',
        changeIframesTheme: changeIframesTheme,
        containerHead: null,

        /**
         *  @desc   模式切换
         *  @param {string} themeString 将要切换到的主题类型
         *  @param {boolean} needCallback 切换完成时是否需要回调, 目前仅需要在用户主动进行主题切换时才需要回调通知。
         */
         changeTheme: function (themeString, needCallback)
         {
            //window.console.log( IFrameLogHeader() +"invoke chagne Theme");
            this.changeIframesTheme(themeString);

            if (this.theme == themeString && this.containerHead === document.documentElement)
            {
                onChangeThemeStart(themeString, needCallback);
                onChangeThemeFinish(themeString, 0, needCallback);

                return;
            }

            this.containerHead = document.documentElement;
            if ('NightMode' == themeString || 'EyeProtect' == themeString)
            {
                var canPreApply = false;
                var func = null;
                if (themeString == 'NightMode')
                {
                    canPreApply = true;
                    func = changeThemeToNightMode;
                }
                else
                {
                    canPreApply = shouldChangeToEyeProtect();
                    func = changeToEyeProtectMode;
                }

                if (canPreApply)
                {
                    applyThemeStyleSheet(themeString); //应用样式
                }

                waitForDocumentReadyToExec(func, needCallback);
            }
            else
            {
                removeThemeStyleSheet();//移除夜间模式的样式
                document.body.clientWidth && //获取client只是为了让webkit进行一次排版渲染，在该函数返回后先变成日间样式
                waitForDocumentReadyToExec(changeThemeToClassicMode, needCallback);
            }

            this.theme = themeString;
        }
    };

    var g_markDocumentReady = false;

    function checkiOS8ReadyState(funToExec,param)
    {
        if (/interactive|complete/.test(document.readyState))
        {
            if (!g_markDocumentReady)
            {
                g_markDocumentReady = true;
                funToExec(param);
            }
        }
        else
        {
            window.setTimeout(checkiOS8ReadyState
                              , 1000
                              , funToExec
                              , param);
        }
    }
    /**
     *  @desc 根据加载状态，执行相应的主题切换
     */
    function waitForDocumentReadyToExec(funToExec, param)
    {
        //window.console.log( IFrameLogHeader() + 'readyStateEvent :' + document.readyState);

        if (/interactive|complete/.test(document.readyState))
        {
            window.setTimeout(funToExec, 1, param);
        }
        else
        {
            document.addEventListener("readystatechange", function abc()
            {
                //window.console.log( IFrameLogHeader() + 'readyStateEvent :' + document.readyState);
                if (document.readyState == "complete")///部分页面太早处理会有问题,参见 0281886
                {
                    if (!g_markDocumentReady)
                    {
                        g_markDocumentReady = true;
                        funToExec(param);
                    }
                    document.removeEventListener("readystatechange", abc, false);
                }
            }, false);

            //<修正iOS 8 兼容性问题,由于iOS 8 无法返回document.readyState
            if (iOSMainVersion() > 7)
            {
                checkiOS8ReadyState(funToExec, param);
            }


        }
    }

    window['UC_shouldChangeTheme']=shouldChangeTheme;
    window['UC_shouldChangeToEyeProtect']=shouldChangeToEyeProtect;
    /**
     *  @desc 监听message
     */
     window.addEventListener('message', function(event)
     {
        if (event.data != 'PREUCBROWSER_THEME_Classic' && event.data != 'PREUCBROWSER_THEME_NightMode' && event.data != 'PREUCBROWSER_THEME_EyeProtect')
        {
            return;
        }

        $UCThemeManager['Theme'].changeTheme(event.data.substring(19));
    }, false);
 })(window);
